using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;

namespace GC_Virtual
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        int numberRows = 50;
        int numberCols = 5;

        private void Form1_Load(object sender, EventArgs e)
        {
            this.gridControl1.QueryCellInfo += new Syncfusion.Windows.Forms.Grid.GridQueryCellInfoEventHandler(gridControl1_QueryCellInfo);
            this.gridControl1.SaveCellInfo += new Syncfusion.Windows.Forms.Grid.GridSaveCellInfoEventHandler(gridControl1_SaveCellInfo);
            this.gridControl1.QueryRowCount += new Syncfusion.Windows.Forms.Grid.GridRowColCountEventHandler(gridControl1_QueryRowCount);
            this.gridControl1.QueryColCount += new Syncfusion.Windows.Forms.Grid.GridRowColCountEventHandler(gridControl1_QueryColCount);

            this.gridControl1.ResetVolatileData();

            this.Text = gridControl1.RowCount.ToString();

             this.gridControl1.OptimizeInsertRemoveCells = false;
        }

        void gridControl1_QueryColCount(object sender, Syncfusion.Windows.Forms.Grid.GridRowColCountEventArgs e)
        {
            e.Count = numberCols;
            e.Handled = true;
        }

        void gridControl1_QueryRowCount(object sender, Syncfusion.Windows.Forms.Grid.GridRowColCountEventArgs e)
        {
            e.Count = numberRows;
            e.Handled = true;
        }

        void gridControl1_SaveCellInfo(object sender, Syncfusion.Windows.Forms.Grid.GridSaveCellInfoEventArgs e)
        {
            e.Handled = true;//save nothing
        }

        Random r = new Random();
        void gridControl1_QueryCellInfo(object sender, Syncfusion.Windows.Forms.Grid.GridQueryCellInfoEventArgs e)
        {
            if (e.RowIndex > 0 && e.ColIndex > 0)
            {
                e.Style.Text = r.Next(1000000).ToString();// DateTime.Now.Millisecond.ToString();
                e.Style.BackColor = Color.FromArgb(Math.Min(228, r.Next(255)), Math.Min(228,r.Next(255)), Math.Min(228,r.Next(255)));
                Console.WriteLine("{0} {1}", e.RowIndex, e.ColIndex);
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            numberRows += 10;

            this.gridControl1.ResetVolatileData();
            this.gridControl1.UpdateScrollBars();

          //  this.Text = gridControl1.RowCount.ToString();
           
        }
    }
}